/***************************************************************************
 *   Copyright (C) 2006 by Ingo Maindorfer								   *
 *   ingo@liquidcooling.de												   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef INVENTORYPROXYMODEL_H
#define INVENTORYPROXYMODEL_H

#include <QSortFilterProxyModel>

class InventoryProxyModel : public QSortFilterProxyModel
{

public:
    enum ViewOption { All, Changed, Patched, Added, Dropped, 
                      Renamed, Missing, Unknown, Ignored };
        
	explicit InventoryProxyModel(QObject * parent, bool folderTree_);
	~InventoryProxyModel(void);
	bool filterAcceptsRow(int sourceRow, const QModelIndex &sourceParent) const;
	bool lessThan(const QModelIndex &left, const QModelIndex &right) const;
	void sort(int column, Qt::SortOrder order = Qt::AscendingOrder); 
    void setHideIgnoredFiles(bool hide);
    void setViewOption(ViewOption opt);
    
private:
	bool folderTree;
	int sortColumn;
    bool hideIgnored;
    ViewOption viewOption;
	Qt::SortOrder sortOrder;
};

#endif
