/***************************************************************************
 *   Copyright (C) 2006 by Jean-Louis Fuchs                                *
 *   ganwell@fangorn.ch                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef TOPOSOT_H
#define TOPOSOT_H

#include "AutomateCommand.h"
#include "MonotoneDelegate.h"

#include <QMap>
#include <QSortFilterProxyModel>

typedef QMap<QString,int> RevisionMap;

class Toposort : public QSortFilterProxyModel, public AutomateCommand
{
      Q_OBJECT
public:
    Toposort(QObject*);
    virtual ~Toposort();
    void setSourceModel(QAbstractItemModel *);
    void sort(int, Qt::SortOrder);

signals:
    void sortingFinished();
    
private:
    void parseOutput();
    bool lessThan(const QModelIndex &, const QModelIndex &) const;
    bool filterAcceptsRow(int, const QModelIndex &) const;

    RevisionMap * ordRevisions;
    MonotoneDelegate * mtnDelegate;
    bool showRows;
    int sortColumn;
    Qt::SortOrder sortOrder;
    
private slots:
    void sortModel();
};

#endif //TOPOSOT_H

