/***************************************************************************
 *   Copyright (C) 2006 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef AUTOMATE_COMMAND_H
#define AUTOMATE_COMMAND_H

#include <QString>

class AutomateCommand
{
public:
    virtual ~AutomateCommand() {}
    inline void setAutomateData(const QString & d) { data = d; }
    inline QString getAutomateData() const { return data; }

    friend class MonotoneDelegate;
    
protected:
    inline virtual bool handleError(int retCode) {
        // Error handling has to happen in the derived classes
        // where each command may decide whether it makes sense
        // to continue program execution (i.e. the error is recoverable)
        // or not
        return false;
    }
    virtual void parseOutput() = 0;
    QString data;
};

#endif
