/***************************************************************************
 *   Copyright (C) 2007 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MONOTONE_DELEGATE_H
#define MONOTONE_DELEGATE_H

#include "AutomateCommand.h"
#include "vocab.h"

#include <QObject>


class MonotoneDelegate : public QObject
{
    Q_OBJECT
    
public:
    MonotoneDelegate(AutomateCommand *);
    ~MonotoneDelegate();
    bool triggerCommand(const QStringList &);
    bool triggerCommand(const QStringList &, const QStringList &);
    
    static QString getBaseWorkspaceRevision(QObject *);
    static QString getOption(QObject *, const QString &);
    static QString getBranchName(QObject *, const QString & defaultBranch = tr("[unknown branch]"));
    static QString getBranchNameShort(QObject *);
    static QStringList resolveSelector(QObject *, const QString &);
    static RevisionCerts getRevisionCerts(QObject *, const QString &);
    static QString getDatabaseFilePath(QObject *);
    static FileEntryList getRevisionManifest(QObject *, const QString &);
    static QStringList getPrivateKeyList(QObject *);

private:
    AutomateCommand * cmdModel;
    int commandNumber;

private slots:
    void commandFinished();
};

#endif
