/***************************************************************************
 *   Copyright (C) 2006 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef FILE_DIFF_H
#define FILE_DIFF_H

#include "Dialog.h"
#include "ui_file_diff.h"
#include "ContentDiff.h"
#include "GetFile.h"
#include "GetFileProxyModel.h"

class FileDiff : public Dialog, private Ui::FileDiffDialog
{
	Q_OBJECT

public:
    FileDiff(QWidget*);
	FileDiff(QWidget*, QString);
    void init(QString);
    
	~FileDiff();

private slots:
    void versionToggled(bool);

private:
    ContentDiff * diffModel;
    GetFile * fileModel;
    GetFileProxyModel * fileProxyModel;
};

#endif
