/***************************************************************************
 *   Copyright (C) 2006 by Thomas Keller                                   *
 *   me@thomaskeller.biz                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "RevisionDiff.h"
#include "Monotone.h"

#include <QHeaderView>

RevisionDiff::RevisionDiff(QWidget* parent) : Dialog(parent) 
{
    setupUi(this);
    Dialog::init();
    
    diffView->setItemsExpandable(true);
    diffView->setRootIsDecorated(true);
    // arrow width is approx. 10px
    diffView->setIndentation(10);
}

void RevisionDiff::init(QString path, QString leftRevision, QString rightRevision)
{
	QString left = tr("base revision");
    QString right = tr("workspace revision");
    
    if (leftRevision.size() > 0)
    {
        left = leftRevision.left(12).append("...");
    }
    
    if (rightRevision.size() > 0)
    {
        right = rightRevision.left(12).append("...");
    }
    
    QString title;
    if (path.size() > 0 && path != ".")
    {
        title = tr("Differences between %1 and %2 in %3")
            .arg(left).arg(right).arg(path);
    }
    else
    {
        title = tr("Differences between %1 and %2")
            .arg(left).arg(right);
    }
    
    setWindowTitle(title);
    
    diffModel = new ContentDiff(this);
    diffView->setModel(diffModel);
    
    // FIXME: proper error handling here
    if (!diffModel->readDiff(path, leftRevision, rightRevision))
    {
        C("Couldn't execute readDiff");
        done(1);
    }
}

RevisionDiff::~RevisionDiff() {}

