#ifndef VOCAB_H
#define VOCAB_H

//
// global macros and defines
//

class Guitone;
#define APP reinterpret_cast<Guitone*>(qApp)
#define MTN(arg) APP->getMonotoneInstance(arg)

// FIXME: uncomment the following lines if you have compile problems
// on Windows using MSVC++
/*
#ifdef _MSC_VER
#define __FUNCTION__ ""
#endif
*/

#ifdef QT_NO_DEBUG
#define D(arg) void()
#else
#define D(arg) qDebug("%s:%s:%d: %s", __FILE__, __FUNCTION__, __LINE__, qPrintable(QString(arg)))
#endif

#define W(arg) qWarning("%s:%s:%d: %s", __FILE__, __FUNCTION__, __LINE__, qPrintable(QString(arg)))
#define C(arg) qCritical("%s:%s:%d: %s", __FILE__, __FUNCTION__, __LINE__, qPrintable(QString(arg)))
#define F(arg) qFatal("%s:%s:%d: %s", __FILE__, __FUNCTION__, __LINE__, qPrintable(QString(arg)))
#define I(arg) if (!(arg)) qFatal("%s:%s:%d: invariant \"%s\" violated", __FILE__, __FUNCTION__, __LINE__, #arg)

//
// type definitions
//

#include <QPair>
#include <QList>

// used for manifest entries, if the bool var is true, the entry is a directory
typedef QPair<QString, bool> FileEntry;
typedef QList<FileEntry> FileEntryList;

// used for revision certs
typedef QString CertKey;
typedef QString CertValue;
typedef QPair<CertKey, CertValue> RevisionCert;
typedef QList<RevisionCert> RevisionCerts;

typedef QList<QByteArray> ByteArrayList;

#endif
